/*
 * $Id: test_dnd.c,v 1.2 2002/02/01 12:53:50 stephen Exp $
 *
 * Test dnd_setup_{load,save}_sel().  We create some file selection widgets
 * then modify them to handle drag and drop.
 */

#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>

#include <gtk/gtk.h>

#include "dnd_filesel.h"

static void open_filesel(GtkWidget *, gpointer);
static void close_filesel(GtkWidget *w, GtkFileSelection *fs);
static void load_it(GtkWidget *w, GtkFileSelection *fs);
int trap_frame_destroy(GtkWidget *widget, GdkEvent *event,
		       gpointer data);

int main(int argc, char *argv[])
{
  GtkWidget *window;
  GtkWidget *vbox;
  GtkWidget *button;
  GtkWidget *fs;

  /* Init GTK (and X) */
  gtk_init(&argc, &argv);

  dnd_hide_file_lists(TRUE);
  /* Create our window.  When it closes the program ends */
  /* window=gtk_window_new(GTK_WINDOW_TOPLEVEL); */
  /* gtk_signal_connect(GTK_OBJECT(window), "destroy", */
		     /* GTK_SIGNAL_FUNC(gtk_main_quit), */
		     /* "WM destroy"); */
  
  /* vbox = gtk_vbox_new(FALSE, 0); */
  /* gtk_container_add(GTK_CONTAINER(window), vbox); */
  /* gtk_widget_show(vbox); */

  /* Create a load file selection widget */
  fs=gtk_file_selection_new("DnD Save Box");
  gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (fs)->ok_button),
			"clicked", (GtkSignalFunc) load_it, fs);
  gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(fs)->
				cancel_button),
			"clicked", (GtkSignalFunc) close_filesel,fs);
  gtk_file_selection_hide_fileop_buttons (GTK_FILE_SELECTION(fs));
  gtk_signal_connect(GTK_OBJECT(fs), "delete_event", 
		     GTK_SIGNAL_FUNC(trap_frame_destroy), 
		     fs);
  /* Make it handle drag and drop loading */
  dnd_setup_load_sel(fs, fs);

  open_filesel(fs, fs);  
  /* gtk_widget_realize(fs); */

  /* Show window */
  /* gtk_widget_show_all(window); */

  /* Loop until done */
  gtk_main();

  return 0;
}

/* Cancel on file selector */
static void close_filesel(GtkWidget *w, GtkFileSelection *fs)
{
  gtk_widget_hide(GTK_WIDGET(fs));
  gtk_widget_destroy(GTK_WIDGET(fs));
  gtk_main_quit;
  exit(0);
}

/* Make a destroy-frame into a close */
int trap_frame_destroy(GtkWidget *widget, GdkEvent *event,
			      gpointer data)
{
  /* Change this destroy into a hide */
  if(GTK_IS_WIDGET(data))
    gtk_widget_hide(GTK_WIDGET(data));
  /* return TRUE; */
  gtk_main_quit;
  exit(0);
}

/* Button clicked, open the file selection widget given as the user data */
static void open_filesel(GtkWidget *widget, gpointer udata)
{
  GtkWidget *fs;

  g_return_if_fail(GTK_IS_FILE_SELECTION(udata));

  fs=GTK_WIDGET(udata);
  dnd_set_mime_type(fs, "text/plain");

  gtk_widget_show(fs);
}

/* Callback for the load file selection widget */
static void load_it(GtkWidget *w, GtkFileSelection *fs)
{
  const char *path=gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs));
  FILE *in;

  /* printf("Selection is: %s\n", path); */
  printf("%s\n", path);

  gtk_widget_hide(GTK_WIDGET(fs));
  gtk_widget_destroy(GTK_WIDGET(fs));
  gtk_main_quit;
  exit(0);
}

